﻿'Programed by NAS6


'行列
Public Class Matrix
    Implements IComparable
    Implements ICloneable

    Public x() As Vector


    Public Function Clone() As Object Implements ICloneable.Clone
        Dim d(Me.x.Length - 1) As Vector
        Dim i As Integer
        For i = 0 To Me.x.Length - 1
            d(i) = Me.x(i).Clone()
        Next
        Return New Matrix(d)
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Matrix = Me
        Dim rh As Matrix = obj
        If Not (lh.x.Length = rh.x.Length And lh.x(0).x.Length = rh.x(0).x.Length) Then
            CompareTo = CompareTo Or 1
        End If
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            If Not lh.x(i) = rh.x(i) Then
                CompareTo = CompareTo Or (2 << i)
            End If
        Next
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Matrix, ByVal rh As Matrix) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Matrix, ByVal rh As Matrix) As Boolean
        Return (Not lh = rh)
    End Operator



    Public Sub New(ByVal m As Integer, ByVal n As Integer)
        ReDim x(m - 1)

        Dim i As Integer
        For i = 0 To m - 1
            x(i) = New Vector(n)
        Next
    End Sub

    Public Sub New(ByVal px() As Vector)
        ReDim x(px.Length - 1)
        Dim i As Integer
        For i = 0 To px.Length - 1
            x(i) = px(i).Clone()
        Next
    End Sub

    Public Sub New(ByVal px(,) As Double, ByVal m As Integer, ByVal n As Integer)
        Dim i As Integer
        Dim j As Integer
        For i = 0 To m - 1
            Dim d(n - 1) As Double
            For j = 0 To n - 1
                d(j) = px(i, j)
            Next
            x(i) = New Vector(d)
        Next
    End Sub

    Public Sub New(ByVal n As Integer)
        ReDim x(n - 1)

        Dim i As Integer
        For i = 0 To n - 1
            x(i) = New Vector(n)
        Next
    End Sub

    '四則演算(便宜上も含む)
    Public Shared Operator +(ByVal lh As Matrix, ByVal rh As Matrix) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = lh.x(0).x.Length) Then
            Return New Matrix(lh.x.Length)
        End If
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) + rh.x(i)
        Next
        Return ret
    End Operator

    Public Shared Operator -(ByVal lh As Matrix, ByVal rh As Matrix) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = lh.x(0).x.Length) Then
            Return New Matrix(lh.x.Length)
        End If
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) - rh.x(i)
        Next
        Return ret
    End Operator

    Public Shared Operator *(ByVal lh As Matrix, ByVal rh As Matrix) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = lh.x(0).x.Length) Then
            Return New Matrix(lh.x.Length)
        End If
        Dim i As Integer
        Dim j As Integer
        Dim t As Matrix = rh.TransposedMat()
        For i = 0 To lh.x.Length - 1
            For j = 0 To lh.x.Length - 1
                ret.x(i).x(j) = lh.x(i) * t.x(j)
            Next
        Next
        Return ret
    End Operator

    Public Shared Operator /(ByVal lh As Matrix, ByVal rh As Matrix) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Or (Not lh.x.Length = lh.x(0).x.Length) Then
            Return New Matrix(lh.x.Length)
        End If
        Dim i As Integer
        Dim j As Integer
        Dim t As Matrix = rh.TransposedMat()
        For i = 0 To lh.x.Length - 1
            For j = 0 To lh.x.Length - 1
                ret.x(i).x(j) = lh.x(i) / t.x(j)
            Next
        Next
        Return ret
    End Operator

    Public Shared Operator *(ByVal lh As Matrix, ByVal rh As Vector) As Vector
        Dim ret As Vector = New Vector(rh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Then
            Return New Vector(rh.x.Length)
        End If
        Dim r As Vector = rh.Clone()
        If r.bHomo Then
            r = r.Homogeneous()
            r.bHomo = False
            ret.bHomo = True
        End If
        Dim i As Integer
        For i = 0 To r.x.Length - 1
            ret.x(i) = lh.x(i) * r
        Next
        Return ret
    End Operator

    Public Shared Operator /(ByVal lh As Matrix, ByVal rh As Vector) As Vector
        Dim ret As Vector = New Vector(rh.x.Length)
        If (Not lh.x.Length = rh.x.Length) Then
            Return New Vector(rh.x.Length)
        End If
        Dim r As Vector = rh.Clone()
        If r.bHomo Then
            r = r.Homogeneous()
            r.bHomo = False
            ret.bHomo = True
        End If
        Dim i As Integer
        For i = 0 To r.x.Length - 1
            ret.x(i) = lh.x(i) / r
        Next
        Return ret
    End Operator

    Public Shared Operator +(ByVal lh As Matrix, ByVal rh As Double) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) + rh
        Next
        Return ret
    End Operator

    Public Shared Operator -(ByVal lh As Matrix, ByVal rh As Double) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) - rh
        Next
        Return ret
    End Operator

    Public Shared Operator *(ByVal lh As Matrix, ByVal rh As Double) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) * rh
        Next
        Return ret
    End Operator

    Public Shared Operator /(ByVal lh As Matrix, ByVal rh As Double) As Matrix
        Dim ret As Matrix = New Matrix(lh.x.Length)
        If rh = 0.0 Then
            Return ret
        End If
        Dim i As Integer
        For i = 0 To lh.x.Length - 1
            ret.x(i) = lh.x(i) / rh
        Next
        Return ret
    End Operator

    '原点マトリクス
    Public Function ZeroMat() As Matrix
        Return New Matrix(Me.x.Length)
    End Function

    '単位マトリクス
    Public Function UnitMat() As Matrix
        Dim ret As Matrix = New Matrix(Me.x.Length)
        Dim w As Vector = New Vector(Me.x.Length)
        Dim i As Integer
        For i = 0 To Me.x.Length - 1
            ret.x(i) = w.UnitVec(i)
        Next
        Return ret
    End Function

    '転置マトリクス
    Public Function TransposedMat() As Matrix
        Dim ret As Matrix = New Matrix(Me.x(0).x.Length, Me.x.Length)
        Dim i As Integer
        Dim j As Integer
        For i = 0 To Me.x(0).x.Length - 1
            For j = 0 To Me.x.Length - 1
                ret.x(i).x(j) = Me.x(j).x(i)
            Next
        Next
        Return ret
    End Function

    'LU分解逆行列呼び出し関数
    Public Function SubLUD(ByVal mx As Matrix, ByVal m As Integer, ByVal n As Integer, ByRef iex As Integer) As Integer
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim aii As Double
        Dim t As Double

        iex = 0
        If m <= 0 Or m > n Then
            Return 1
        End If
        If m > 1 Then
            For i = 0 To m - 1 - 1
                For j = i To m - 1
                    aii = mx.x(j).x(i)
                    If aii Then
                        Exit For
                    End If
                Next
                If aii = 0.0 Then
                    Return 2
                End If
                If Not j = i Then
                    For k = 0 To n - 1
                        t = mx.x(i).x(k)
                        mx.x(i).x(k) = mx.x(j).x(k)
                        mx.x(j).x(k) = t
                    Next
                    iex = iex + 1
                End If
                For j = i + 1 To m - 1
                    t = mx.x(j).x(i) / aii
                    mx.x(j).x(i) = t
                    For k = i + 1 To n - 1
                        mx.x(j).x(k) = mx.x(j).x(k) - (mx.x(i).x(k) * t)
                    Next
                Next
            Next
            If m = n Then
                Return 0
            End If
        End If
        aii = 1.0 / mx.x(m - 1).x(m - 1)
        For i = m To n - 1
            mx.x(m - 1).x(i) = mx.x(m - 1).x(i) * aii
        Next
        If m = 1 Then
            Return 0
        End If
        For i = m - 2 To 0 Step -1
            aii = mx.x(i).x(i)
            For j = m To n - 1
                t = 0.0
                For k = m - 1 To i + 1 Step -1
                    t = t + mx.x(i).x(k) * mx.x(k).x(j)
                Next
                mx.x(i).x(j) = (mx.x(i).x(j) - t) / aii
            Next
        Next
        Return 0
    End Function

    'LU分解逆行列
    Public Function LUDMat(ByRef l As Matrix, ByRef u As Matrix, ByRef dt As Double) As Matrix
        Dim ll As Matrix = New Matrix(Me.x.Length, Me.x.Length)
        Dim w As Matrix = New Matrix(Me.x.Length, Me.x.Length * 2)
        Dim ret As Matrix = New Matrix(Me.x.Length, Me.x.Length)
        Dim iex As Integer = 0
        Dim i As Integer
        Dim j As Integer
        Dim m As Integer = Me.x.Length
        Dim n As Integer = m + m
        For i = 0 To m - 1
            For j = 0 To n - 1
                If j < m Then
                    w.x(i).x(j) = Me.x(i).x(j)
                ElseIf j = i + m Then
                    w.x(i).x(j) = 1.0
                Else
                    w.x(i).x(j) = 0.0
                End If
            Next
        Next
        Dim ier As Integer = SubLUD(w, m, n, iex)
        If ier Then
            Return ret.ZeroMat()
        End If
        dt = 1.0
        For i = 0 To m - 1
            For j = 0 To m - 1
                If j < i Then
                    l.x(i).x(j) = w.x(i).x(j)
                    u.x(i).x(j) = 0.0
                ElseIf j = i Then
                    l.x(i).x(j) = 1.0
                    u.x(i).x(j) = w.x(i).x(j)
                    dt = dt * w.x(i).x(j)
                Else
                    l.x(i).x(j) = 0.0
                    u.x(i).x(j) = w.x(i).x(j)
                End If
            Next
        Next
        If iex Mod 2 Then
            dt = -dt
        End If
        For i = 0 To m - 1
            For j = 0 To m - 1
                ret.x(i).x(j) = w.x(i).x(j + m)
            Next
        Next
        Return ret
    End Function

    '連立1次方程式解法
    Public Function SimEQ(ByVal m As Integer, ByVal n As Integer, ByRef dt As Double) As Matrix
        Dim ret As Matrix = New Matrix(Me.x.Length, Me.x(0).x.Length)
        Dim ax As Double
        Dim d As Double
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        If m < 1 Or m > n Then
            dt = 0.0
            ret.ZeroMat()
            Return ret
        End If

        If m = 1 Then
            d = Me.x(0).x(0)
            If d Then
                For i = 0 To n - 1
                    ret.x(0).x(i) = Me.x(0).x(i) / d
                Next
            End If
            dt = d
            Return ret
        End If
        d = 1.0
        For i = 0 To m - 1
            j = i
            While True
                If j >= m Then
                    dt = 0.0
                    ret.ZeroMat()
                    Return ret
                End If
                If Me.x(j).x(i) Then
                    Exit While
                End If
                j = j + 1
            End While
            If Not j = i Then
                For k = i To n - 1
                    ax = Me.x(i).x(k)
                    Me.x(i).x(k) = Me.x(j).x(k)
                    Me.x(j).x(k) = ax
                Next
                d = -d
            End If

            ax = Me.x(i).x(i)
            d = d * ax
            Me.x(i).x(i) = 1.0

            For j = i + 1 To n - 1
                Me.x(i).x(j) = Me.x(i).x(j) / ax
            Next
            For j = 0 To m - 1
                If Not i = j Then
                    ax = Me.x(j).x(i)
                    Me.x(j).x(i) = 0.0
                    For k = i + 1 To n - 1
                        Me.x(j).x(k) = Me.x(j).x(k) - Me.x(i).x(k) * ax
                    Next
                End If
            Next
        Next
        dt = d
        ret = Me
        Return ret
    End Function

    '逆行列
    Public Function InverseMat(ByRef dt As Double) As Matrix
        Return InverseMat00(dt)
        'Return InverseMat01(dt)
    End Function

    '逆行列
    Public Function InverseMat00(ByRef dt As Double) As Matrix
        Dim m As Integer = Me.x.Length
        Dim n As Integer
        Dim i As Integer
        Dim j As Integer
        Dim a As Matrix = New Matrix(Me.x.Length, Me.x.Length * 2)
        Dim ret As Matrix = New Matrix(Me.x.Length, Me.x.Length)

        If m < 1 Then
            Return Me.ZeroMat
        End If
        n = m + m

        For i = 0 To m - 1
            For j = 0 To m - 1
                a.x(i).x(j) = Me.x(i).x(j)
            Next
        Next
        For i = 0 To m - 1
            For j = 0 To m - 1
                If i = j Then
                    a.x(i).x(j + m) = 1.0
                Else
                    a.x(i).x(j + m) = 0.0
                End If
            Next
        Next

        a.SimEQ(m, n, dt)

        For i = 0 To m - 1
            For j = 0 To m - 1
                ret.x(i).x(j) = a.x(i).x(j + m)
            Next
        Next

        Return ret
    End Function

    '逆行列掃き出し法
    Public Function InverseMat01(ByRef dt As Double) As Matrix
        dt = -1
        Dim ret As New Matrix(Me.x.Length, Me.x(0).x.Length)
        ret = ret.UnitMat()
        If Not ret.x.Length = ret.x(0).x.Length Then
            Return ret
        End If
        Dim wk As Matrix = Me.Clone()
        Dim buf As Double
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim n As Integer = ret.x.Length - 1
        For i = 0 To n
            buf = 1.0 / wk.x(i).x(i)
            For j = 0 To n
                wk.x(i).x(j) *= buf
                ret.x(i).x(j) *= buf
            Next
            For j = 0 To n
                If Not i = j Then
                    buf = wk.x(j).x(i)
                    For k = 0 To n
                        wk.x(j).x(k) -= wk.x(i).x(k) * buf
                        ret.x(j).x(k) -= ret.x(i).x(k) * buf
                    Next
                End If
            Next
        Next
        Return ret
    End Function

    '行列式
    Public Function DeterminMat() As Double
        Dim l As Matrix = New Matrix(Me.x.Length, Me.x.Length)
        Dim u As Matrix = New Matrix(Me.x.Length, Me.x.Length)
        Dim dt As Double
        Dim mx As Matrix = Me.LUDMat(l, u, dt)
        Return dt
    End Function

    Public Function fabs(ByVal x As Double) As Double
        fabs = x
        If fabs < 0.0 Then
            fabs = fabs * -1.0
        End If
    End Function

    '実対称行列の固有値・固有ベクトル（ヤコビ法）
    'n : 次数                                             
    'ct : 最大繰り返し回数                                
    'eps : 収束判定条件                                   
    'A : 対象とする行列                                   
    'A1, A2 : 作業域（nxnの行列），A1の対角要素が固有値   
    'X1, X2 : 作業域（nxnの行列），X1の各列が固有ベクトル 
    'return : =0 : 正常                                   
    '=1 : 収束せず                               
    Public Function Jacobi(ByVal n As Integer, ByVal ct As Integer, ByVal eps As Double, ByRef A As Matrix, ByRef A1 As Matrix, ByRef A2 As Matrix, ByRef X1 As Matrix, ByRef X2 As Matrix) As Integer
        Dim max As Double
        Dim s As Double
        Dim t As Double
        Dim v As Double
        Dim sn As Double
        Dim cs As Double

        Dim i1 As Integer
        Dim i2 As Integer
        Dim k As Integer = 0
        Dim ind As Integer = 1
        Dim p As Integer = 0
        Dim q As Integer = 0

        '初期設定
        For i1 = 0 To n - 1
            For i2 = 0 To n - 1
                A1.x(i1).x(i2) = A.x(i1).x(i2)
                X1.x(i1).x(i2) = 0.0
            Next
            X1.x(i1).x(i1) = 1.0
        Next
        '計算
        While (ind > 0 And k < ct)
            '最大要素の探索
            max = 0.0
            For i1 = 0 To n - 1
                For i2 = 0 To n - 1
                    If Not i2 = i1 Then
                        If fabs(A1.x(i1).x(i2)) > max Then
                            max = fabs(A1.x(i1).x(i2))
                            p = i1
                            q = i2
                        End If
                    End If
                Next
            Next
            '収束判定
            If max < eps Then '収束した
                ind = 0
            Else '収束しない
                '準備
                s = -A1.x(p).x(q)
                t = 0.5 * (A1.x(p).x(p) - A1.x(q).x(q))
                v = fabs(t) / Math.Sqrt(s * s + t * t)
                sn = Math.Sqrt(0.5 * (1.0 - v))
                If s * t < 0.0 Then
                    sn = -sn
                End If
                cs = Math.Sqrt(1.0 - sn * sn)
                'Akの計算
                For i1 = 0 To n - 1
                    If i1 = p Then
                        For i2 = 0 To n - 1
                            If i2 = p Then
                                A2.x(p).x(p) = A1.x(p).x(p) * cs * cs + A1.x(q).x(q) * sn * sn - 2.0 * A1.x(p).x(q) * sn * cs
                            ElseIf i2 = q Then
                                A2.x(p).x(q) = 0.0
                            Else
                                A2.x(p).x(i2) = A1.x(p).x(i2) * cs - A1.x(q).x(i2) * sn
                            End If
                        Next
                    ElseIf i1 = q Then
                        For i2 = 0 To n - 1
                            If i2 = q Then
                                A2.x(q).x(q) = A1.x(p).x(p) * sn * sn + A1.x(q).x(q) * cs * cs + 2.0 * A1.x(p).x(q) * sn * cs
                            ElseIf i2 = p Then
                                A2.x(q).x(p) = 0.0
                            Else
                                A2.x(q).x(i2) = A1.x(q).x(i2) * cs + A1.x(p).x(i2) * sn
                            End If

                        Next
                    Else
                        For i2 = 0 To n - 1
                            If i2 = p Then
                                A2.x(i1).x(p) = A1.x(i1).x(p) * cs - A1.x(i1).x(q) * sn
                            ElseIf i2 = q Then
                                A2.x(i1).x(q) = A1.x(i1).x(q) * cs + A1.x(i1).x(p) * sn
                            Else
                                A2.x(i1).x(i2) = A1.x(i1).x(i2)
                            End If
                        Next
                    End If
                Next
                'Xkの計算
                For i1 = 0 To n - 1
                    For i2 = 0 To n - 1
                        If i2 = p Then
                            X2.x(i1).x(p) = X1.x(i1).x(p) * cs - X1.x(i1).x(q) * sn
                        ElseIf i2 = q Then
                            X2.x(i1).x(q) = X1.x(i1).x(q) * cs + X1.x(i1).x(p) * sn
                        Else
                            X2.x(i1).x(i2) = X1.x(i1).x(i2)
                        End If
                    Next
                Next
                '次のステップへ
                k = k + 1
                For i1 = 0 To n - 1
                    For i2 = 0 To n - 1
                        A1.x(i1).x(i2) = A2.x(i1).x(i2)
                        X1.x(i1).x(i2) = X2.x(i1).x(i2)
                    Next
                Next
            End If
        End While
        Return ind
    End Function

    '実対称行列の固有値・固有ベクトル（ヤコビ法）
    'ct : 最大繰り返し回数                                
    'eps : 収束判定条件                                   
    'A : 対象とする行列                                   
    'det : 固有値   
    'eigen :固有ベクトル 
    'return : =0 : 正常                                   
    '=1 : 収束せず                               
    Public Function EigenVec(ByVal ct As Integer, ByVal eps As Double, ByRef A As Matrix, ByRef det As Vector, ByVal eigen As Matrix) As Integer
        If Not A.x.Length = A.x(0).x.Length Then
            Return 1
        End If
        If Not A.x.Length = det.x.Length Then
            Return 1
        End If
        If Not (A.x.Length = eigen.x.Length And eigen.x.Length = eigen.x(0).x.Length) Then
            Return 1
        End If
        Dim A1 As Matrix = New Matrix(A.x.Length)
        Dim A2 As Matrix = New Matrix(A.x.Length)
        Dim X1 As Matrix = New Matrix(A.x.Length)
        Dim X2 As Matrix = New Matrix(A.x.Length)
        Dim n As Integer = A.x.Length
        Dim i1 As Integer
        Dim i2 As Integer
        EigenVec = Jacobi(n, ct, eps, A, A1, A2, X1, X2)
        If EigenVec = 0 Then
            For i1 = 0 To n - 1
                det.x(i1) = A1.x(i1).x(i1)
            Next
            For i1 = 0 To n - 1
                For i2 = 0 To n - 1
                    eigen.x(i1).x(i2) = X1.x(i1).x(i2)
                Next
            Next
        End If
    End Function

    '対角化行列
    Public Function DiagonalMat(ByVal ct As Integer, ByVal eps As Double) As Matrix
        Dim det As Vector = New Vector(Me.x.Length)
        Dim eigen As Matrix = New Matrix(Me.x.Length)
        If Not EigenVec(ct, eps, Me, det, eigen) = 0 Then
            Return New Matrix(Me.x.Length)
        End If
        DiagonalMat = New Matrix(Me.x.Length)
        Dim n As Integer = Me.x.Length
        Dim i1 As Integer
        Dim i2 As Integer
        For i1 = 0 To n - 1
            For i2 = 0 To n - 1
                DiagonalMat.x(i1).x(i2) = eigen.x(i1).x(i2)
            Next
        Next
    End Function

    '対角化行列
    Public Function DiagonalMat() As Matrix
        Return DiagonalMat(1000, 0.0000000001)
    End Function

    '対角化
    Public Function Diagonal(ByVal ct As Integer, ByVal eps As Double) As Matrix
        Dim det As Vector = New Vector(Me.x.Length)
        Dim eigen As Matrix = New Matrix(Me.x.Length)
        If Not EigenVec(ct, eps, Me, det, eigen) = 0 Then
            Return New Matrix(Me.x.Length)
        End If
        Diagonal = New Matrix(Me.x.Length)
        Dim n As Integer = Me.x.Length
        Dim i1 As Integer
        For i1 = 0 To n - 1
            Diagonal.x(i1).x(i1) = det.x(i1)
        Next
    End Function

    '対角化
    Public Function Diagonal() As Matrix
        Return Diagonal(1000, 0.0000000001)
    End Function

    '軸に対する回転
    Public Function RotAxisMat(ByVal axis As Vector, ByVal theta As Double) As Matrix
        If Not ((Me.x.Length = 3 And Me.x(0).x.Length = 3 And Me.x.Length = axis.x.Length) Or _
                (Me.x.Length = 4 And Me.x(0).x.Length = 4 And Me.x.Length = axis.x.Length)) Then
            Return New Matrix(Me.x.Length)
        End If
        Dim vwk As New Vector(3)
        Dim mwk As New Matrix(3)
        If Me.x.Length = 3 Then
            vwk = axis.Clone()
            mwk = Me.Clone()
        Else
            vwk = axis.ToNormal()
        End If

        vwk = vwk / vwk.Abs()
        Dim c As Double = Math.Cos(theta)
        Dim s As Double = Math.Sin(theta)
        Dim d As Matrix = New Matrix(3)
        d.x(0).x(0) = c + vwk.x(0) * vwk.x(0) * (1.0 - c)
        d.x(0).x(1) = vwk.x(0) * vwk.x(1) * (1.0 - c) - vwk.x(2) * s
        d.x(0).x(2) = vwk.x(0) * vwk.x(2) * (1.0 - c) + vwk.x(1) * s
        d.x(1).x(0) = vwk.x(1) * vwk.x(0) * (1.0 - c) + vwk.x(2) * s
        d.x(1).x(1) = c + vwk.x(1) * vwk.x(1) * (1.0 - c)
        d.x(1).x(2) = vwk.x(1) * vwk.x(2) * (1.0 - c) - vwk.x(0) * s
        d.x(2).x(0) = vwk.x(2) * vwk.x(0) * (1.0 - c) - vwk.x(1) * s
        d.x(2).x(1) = vwk.x(2) * vwk.x(1) * (1.0 - c) + vwk.x(0) * s
        d.x(2).x(2) = c + vwk.x(2) * vwk.x(2) * (1.0 - c)
        If Me.x.Length = 3 Then
            Return d
        Else
            Dim ret As New Matrix(4)
            Dim i As Integer = 0
            ret.x(i) = ret.x(i).UnitVec(0)
            For i = 0 To 2
                ret.x(i + 1) = d.x(i).ToHomo()
                ret.x(i + 1).x(0) = 0.0
            Next
            Return ret
        End If
    End Function

    '同次座標
    Public Function Homogeneous() As Matrix
        Dim IntWK1 As Integer = 0
        Dim IntWK2 As Integer = 0
        Dim MatWK As New Matrix(Me.x.Length)
        MatWK = MatWK.UnitMat()
        If Me.x(0).x(0) = 0.0 Then
            Return MatWK
        End If
        For IntWK1 = 1 To Me.x.Length - 1
            For IntWK2 = 0 To Me.x(0).x.Length - 1
                MatWK.x(IntWK1).x(IntWK2) = Me.x(IntWK1).x(IntWK2) / Me.x(0).x(0)
            Next
        Next
        Return MatWK
    End Function

    Public Function Pos() As Vector
        Pos = New Vector(4, True)
        Pos = Pos.ZeroVec()
        Pos = Me * Pos
    End Function

    Public Function Quaternion() As Quaternion
        Dim ret As New Quaternion
        Dim m As Matrix = Me.Clone()
        m = m.Homogeneous()
        Dim s As Double
        Dim tr As Double = m.x(1).x(1) + m.x(2).x(2) + m.x(3).x(3) + m.x(0).x(0)
        If 1.0 <= tr Then
            s = 0.5 / Math.Sqrt(tr)
            ret.q.x(0) = 0.25 / s
            ret.q.x(1) = (m.x(2).x(3) - m.x(3).x(2)) * s
            ret.q.x(2) = (m.x(3).x(1) - m.x(1).x(3)) * s
            ret.q.x(3) = (m.x(1).x(2) - m.x(2).x(1)) * s
        Else
            Dim max As Double
            If m.x(3).x(3) < m.x(2).x(2) Then
                max = m.x(2).x(2)
            Else
                max = m.x(3).x(3)
            End If
            If max < m.x(1).x(1) Then
                s = Math.Sqrt(m.x(1).x(1) - (m.x(2).x(2) + m.x(3).x(3)) + m.x(0).x(0))
                Dim x As Double = s * 0.5
                s = 0.5 / s
                ret.q.x(0) = (m.x(2).x(3) - m.x(3).x(2)) * s
                ret.q.x(1) = x
                ret.q.x(2) = (m.x(1).x(2) + m.x(2).x(1)) * s
                ret.q.x(3) = (m.x(3).x(1) + m.x(1).x(3)) * s
            ElseIf max = m.x(2).x(2) Then
                s = Math.Sqrt(m.x(2).x(2) - (m.x(3).x(3) + m.x(1).x(1)) + m.x(0).x(0))
                Dim y As Double = s * 0.5
                s = 0.5 / s
                ret.q.x(0) = (m.x(3).x(1) - m.x(1).x(3)) * s
                ret.q.x(1) = (m.x(1).x(2) + m.x(2).x(1)) * s
                ret.q.x(2) = y
                ret.q.x(3) = (m.x(2).x(3) + m.x(3).x(2)) * s
            Else
                s = Math.Sqrt(m.x(3).x(3) - (m.x(1).x(1) + m.x(2).x(2)) + m.x(0).x(0))
                Dim z As Double = s * 0.5
                s = 0.5 / s
                ret.q.x(0) = (m.x(1).x(2) - m.x(2).x(1)) * s
                ret.q.x(1) = (m.x(3).x(1) + m.x(1).x(3)) * s
                ret.q.x(2) = (m.x(2).x(3) + m.x(3).x(2)) * s
                ret.q.x(3) = z
            End If
        End If
        Return ret
    End Function


    Public Function NormalRotMat() As Matrix
        Dim i As Integer
        Dim d As Double
        Dim ret As New Matrix(Me.x.Length)
        ret = Me.Homogeneous()
        For i = 1 To Me.x.Length - 1
            d = ret.x(i).x(0)
            ret.x(i).x(0) = 0.0
            ret.x(i) = ret.x(i).NormalVec()
            ret.x(i).x(0) = d
        Next
        Return ret
    End Function
End Class
